(*
   CS 31600
   Assignment 5
   Solutions

   From pages 115-116 of the textbook.
   Exercise 2
   Exercise 3
   Exercise 4

   Exercise 6': Write a function insert that takes as input a number and a sorted list of numbers and outputs a list with the number inserted into the list at the correct place so that the returned list is still sorted. Do this recursively and use pattern matching. (You need to consider only three cases: the given list is empty, the given number is less than the first element of the list, or the given number is greater than the first element of the list.)

   Exercise 6'': Use your insert function to write a sort function (a recursive version of "insertion sort").

   Exercise 7': Do Exercise 7 but with your sort function instead of the book's quicksort function. You will need to modify your version of insert. Give examples of using your new sort function to sort a list of integers, and also a list of reals. (What about a list of char?). Notice that this is somewhat like a "generic" function in Java, or a "template" function in C++.

   Exercise 8': Write a function twiddle that takes as input a list of triples, and returns a list of pairs where each triple from the input has its middle element removed and its first and third elements swapped. Write this using pattern matching.

   Exercise 9': Write a function flipper that flips alternate elements from a list. So if the input list is [a1, a2, a3, a4, a5, a6], then the output list should be [a2, a1, a4, a3, a6, a5]. If the length of the input list is odd, then the last element of the input list should also be the last element of the output list.
*)


(* Excercise 2, page 115 *)

fun member (e, nil) = false
 |  member (e, x::xs) =
      if e = x then
        true
      else
        member (e, xs);

(* here is a more elegant version *)
fun member (_, nil) = false
 |  member (e, x::xs) = (e = x) orelse member (e, xs);


(* Excercise 3, page 116 *)

fun less (_, nil) = nil
 |  less (e, x::xs) =
      if x < e then
        x :: less (e, xs)
      else
        less (e, xs);


(* Excercise 4, page 116 *)

fun repeats nil = false
 |  repeats (_::nil) = false
 |  repeats (x::y::cs) = (x = y) orelse repeats (y::cs);


(* Excercise 6' *)

fun insert (e, nil) = e :: nil
 |  insert (e, x::xs) =
      if x < e then
        x::insert (e, xs)
      else
        e::x::xs;


(* Excercise 6'' *)

fun sort nil = nil
 |  sort (x::xs) = insert (x, sort(xs));

(* NOTE: Exercises 6' and 6'' together define a "non generic"
         insertion sort. That means that they can only sort
         one kind of data type, a list of integers. What if
         you want to sort reals, or chars, or strings? What
         if you want a decreasing sorted order instead of an
         increasing sorted order? Exercise 7' defines a
         "generic" insertion sort that can sort many data types. *)


(* Excercise 7', pages 116-117 *)

fun insert2 (e,   nil, cmp) = e::nil
 |  insert2 (e, x::xs, cmp) =
      if cmp(x ,e) then
        x::insert2 (e, xs, cmp)
      else
        e::x::xs;

fun sort2 (nil, _) = nil
 |  sort2 (x::xs, cmp) = insert2 (x, sort2(xs, cmp), cmp);
(* Notice how passing the comparison function around gets kind of ugly. *)


(* Here are a few comparison functions, from page 117 of the textbook. *)
fun icmp (a, b) = a < b;
fun ircmp(a, b) = a > b;
fun rcmp (a : real, b : real) = a < b;
fun rrcmp(a : real, b : real) = a > b;
fun ccmp (a : char, b : char) = a < b
fun crcmp(a : char, b : char) = a > b

(* Here is the generic insertion sort with insert and sort as inner functions. *)
(* Notice how insert "inherits" the comparison function from sortG. *)
(* This solves the "ugliness" of passing the comparison function around. *)
fun sortG (x, cmp) =
  let
    fun insert (e, nil) = e::nil
     |  insert (e, x::xs) =
          if cmp(x, e) then
            x::insert (e, xs)
          else
            e::x::xs;
    fun sort nil = nil
     |  sort (x::xs) = insert (x, sort(xs));
  in
    sort (x)
  end;


(* Excercise 8' *)

fun twiddle nil = nil
 |  twiddle ((a, b, c)::xs)  = (c, a)::twiddle xs;


(* Excercise 9' *)

fun flipper nil = nil
 |  flipper (x::nil) = x::nil
 |  flipper (x::y::cs) = y::x::flipper cs;